package com.ruoyi.bst.order.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ruoyi.bst.order.domain.OrderVO;
import com.ruoyi.bst.order.domain.bo.OrderRidePaySuccessBO;
import com.ruoyi.bst.order.domain.enums.OrderPayType;
import com.ruoyi.bst.order.service.OrderService;
import com.ruoyi.bst.pay.domain.PayVO;
import com.ruoyi.bst.pay.interfaces.PayHandler;
import com.ruoyi.common.utils.ServiceUtil;

@Service
public class OrderRidePayHandlerImpl implements PayHandler {
    
    @Autowired
    private OrderService orderService;

    @Override
    public boolean onPaySuccess(PayVO pay) {
        // 查询订单
        OrderVO order = orderService.selectOrderById(pay.getBstId());
        ServiceUtil.assertion(order == null, "订单不存在");

        // 处理骑行费支付成功
        OrderRidePaySuccessBO bo = new OrderRidePaySuccessBO();
        bo.setOrder(order);
        bo.setPayType(OrderPayType.USER_PAY);
        bo.setPayAmount(pay.getAmount());
        bo.setIgnoreVerify(false);
        bo.setPayId(pay.getId());
        bo.setPayTime(pay.getPayTime());
        int rows = orderService.handleRidePaySuccess(bo);

        return rows == 1;
    }
}
