package com.ruoyi.bst.pay.service.impl;

import com.ruoyi.bst.app.domain.AppVO;
import com.ruoyi.bst.channel.domain.ChannelVO;
import com.ruoyi.bst.pay.service.PayValidator;
import com.ruoyi.bst.userApp.domain.UserAppVO;
import com.ruoyi.common.utils.ServiceUtil;
import org.springframework.stereotype.Service;

@Service
public class PayValidatorImpl implements PayValidator{

    /**
     * 应用与渠道校验
     * @param app 应用
     * @param channel 渠道
     */
    @Override
    public void checkPay(AppVO app, ChannelVO channel, UserAppVO userApp) {
        // 应用
        ServiceUtil.assertion(app == null || app.getId() == null, "应用不存在");

        // 渠道
        ServiceUtil.assertion(channel == null || channel.getChannelId() == null, "渠道不存在");
        ServiceUtil.assertion(channel.getEnabled() == null || !channel.getEnabled(), "当前渠道暂不可用");
        ServiceUtil.assertion(channel.getAppIds() == null || !channel.getAppIds().contains(app.getId()), "ID为%s的渠道不支持ID为%s的应用", channel.getChannelId(), app.getId());

        // 用户应用
        ServiceUtil.assertion(userApp == null, "用户在%s应用中未绑定账号", app.getName());
    }
}
